#define input_vbat 0
#define input_vref 3

u16 read_adc(u8 cnl)
{
  ADC1->CR1 &= ~ADC1_CR1_ADON; 
  ADC1->CSR = cnl;
  ADC1->CR1 |= ADC1_CR1_ADON;
  ADC1->CR1 |= ADC1_CR1_ADON;
  while(!(ADC1->CSR&ADC1_CSR_EOC));
  ADC1->CR1 &= ~ADC1_CR1_ADON;
  u16 data = 0;
  for(u8 i=0;i<10;i++)data += *((u16*)&ADC1->DB0RH+i);
  return data/=10; 
}

u16 calc_Vbat(void)
{
 u16 m_ref=read_adc(input_vref); 
 u16 m_bat=read_adc(input_vbat); 
 
 u32 Vcc = eep.Vref*0x3ff/m_ref;
 u32 maxV = Vcc*(eep.R1+eep.R2)/eep.R2;
 return maxV*m_bat/0x3ff;
}

bool check_bat(void)
{
 static u16 lbt_trs = (u32)8000*0x3ff*eep.R2/(eep.R1+eep.R2)/eep.Vcc;
 
 if(ADC1->CSR&0x0f == input_vbat)
 {
  if(ADC1->CSR&ADC1_CSR_EOC)
  {
   ADC1->CR1 &= ~ADC1_CR1_ADON; 
   ADC1->CSR = input_vbat;
   u16 data = 0; 
   for(u8 i=0;i<8;i++)data += *((u16*)&ADC1->DB0RH+i); 
   ADC1->CR1 |= ADC1_CR1_ADON; 
   ADC1->CR1 |= ADC1_CR1_ADON;   
   if(data>>=3 < lbt_trs)return 0;
   else return 1;
  } 
  else ADC1->CR1 |= ADC1_CR1_ADON; 
 }
 else 
 {
  ADC1->CR1 &= ~ADC1_CR1_ADON;
  ADC1->CSR  = input_vbat;
  ADC1->CR1 |= ADC1_CR1_ADON; 
 }

 return 1; 
}